
// LISTING 2:
// demoport.cpp
// DEMO PROGRAM FOR OUTPORT CLASS

// Eric Horner, Sundstrand Research Dept., Rockford, IL. May 1990

#include "outport.hpp"
#include <stdio.h>

char *valve_ptr;

main()
{
    // declare a dummy "port"
    char dummy = ' .';
    valve_ptr = &dummy;
    
    // declare an output port, "valves", at address "valve_ptr"
    outport valves(valve_ptr);

    // clear all valves
    printf("\nclear all bits:\n");
    valves.clear_all();
    valves.print_port();

    // set bits 5 to 7 of valves, utilizing defaults
    printf("\nset bits 5 thro' 7");
    valves.set_bits(5, 7);
    valves.print_port();

    // set bit 5 only, of valves..
    printf("\nset bit 5 only:\n");
    valves.clear_all();
    valves.set_bit(5);
    valves.print_port();

    // send 20 clock pulses to bit 5 of valves
    for(int i = 0; i < 40; i++)
        valves.toggle_bit(5);

    // set some bits in valves, with error checking
    printf("\nset with bits out of range:\n");
    if (valves.set_bits(2, 25) == FALSE)
        fprintf(stderr, "\nSet-bits out of range");

    // and so on......
}
