
// LISTING 1:

// OUTPORT.HPP - A possible class interface for bitwise output to a 
// port, of user-defined size (any number of bits, 1 to sizeof(int).

// Eric Horner, Sundstrand Research Dept., Rockford, IL. May 1990

#ifndef	OUTPORT_HPP
#define OUTPORT_HPP	1

enum boolean {FALSE, TRUE};


//// class outport //// bitwise port output class ////
class outport
{
    char *port_address;
    int maxbit;

  public:
    outport(char *address);					// constructor

    void print_port();			 // prints out bit states (debug only)

    // assortment of bit setting methods, with return value of:
    // TRUE = done, FALSE = out of range, or other reason not done
    boolean set_bit(int bit_number);			      // one at a time
    boolean set_bits(int, int, int, int);		    // four at a time!
    boolean set_bits(int start, int end);		      // range of bits
    boolean set_all();					  // all together now!

    // similar for bit clearing
    boolean clear_bit(int bit_number);
    boolean clear_bits(int, int, int, int);
    boolean clear_bits(int start, int end);
    boolean clear_all();

    // similar for bit toggling
    boolean toggle_bit(int bit_number);
    boolean toggle_bits(int, int, int, int);
    boolean toggle_bits(int start, int end);
    boolean toggle_all();

    // similar for shifts - default to one bit shift
    // (not implemented at present time)
    boolean shift_right(int how_many = 1);
    boolean shift_left(int how_many = 1); 
    boolean rotate_right(int how_many = 1);
    boolean rotate_left(int how_many = 1);
};

#endif
// END OUTPORT.HPP
